function [R,R1,R2,Envelope,Local_Orientation,Local_Phase,PM_carrier]=Riesz(Image2D,Filter)
%**********************************************************************************************
%%%Ignacio Serrano-Pedraza & Vicente Sierra-Vazquez 2010
%%%(i.s.pedraza@ncl.ac.uk)


%%%01-07-2010
warning off
SIZE=size(Image2D);

degreesimagex=1;%%Using 1 degree is like define the spatial frequency in c/iw (cycles per image width)
degreesimagey=1;
SIZEX=SIZE(1);
SIZEY=SIZE(2);

gx=degreesimagex/SIZEX;%Degrees of visual angle x
gy=degreesimagey/SIZEY;%Degrees of visual angle y

fNu=(SIZEX/degreesimagex)/2; %Nyquist frequency axis u
fNv=(SIZEY/degreesimagey)/2; %Nyquist frequency axis v
fu=fNu*2/SIZEX; %sampling rate in frequency, axis u cycles/degree
fv=fNv*2/SIZEY; %sampling rate in frequency, axis v cycles/degree

[u,v]=meshgrid(-fNu:(2*fNu/SIZEX):fNu-(2*fNu/SIZEX),fNv:-(2*fNv/SIZEY):-(fNv-(2*fNv/SIZEY)));
anglefilt=0*pi/180;
u0=0;
v0=0;
ucord=(u-u0)*cos(anglefilt)+(v-v0)*sin(anglefilt);
vcord=-(u-u0)*sin(anglefilt)+(v-v0)*cos(anglefilt);


%%%%%%%%%%%%%%%%%Contrast function of the original image%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
I=Image2D;
Lave=sum(sum(I.*gx*gy))./(degreesimagex*degreesimagey);%%average luminance
c=(I-Lave)./Lave;%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


H_BP=Filter;%%Band-pass filter
H1=(ucord./(sqrt(ucord.^2+vcord.^2))).*Filter;
H1(SIZEX/2+1,SIZEX/2+1)=0;
H2=(vcord./(sqrt(ucord.^2+vcord.^2))).*Filter;
H2(SIZEX/2+1,SIZEX/2+1)=0;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%MONOGENIC COMPONENTS%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
FFTimage=(fftshift(fft2(c)));
PHASEimage=angle(FFTimage);
FFTabs=abs(FFTimage);
REALPROD=fftshift(H_BP.*FFTabs.*cos(PHASEimage));
IMAGPROD=fftshift(H_BP.*FFTabs.*sin(PHASEimage));
Result=(REALPROD+IMAGPROD*sqrt(-1));
FINAL=ifft2(Result);
R=real(FINAL);


absH1=sqrt((0.*ones(SIZEX,SIZEY)).^2+H1.^2);
PhaseH1=atan2(H1,(0.*ones(SIZEX,SIZEY)));
REALPROD=fftshift(absH1.*FFTabs.*cos(PHASEimage+PhaseH1));
IMAGPROD=fftshift(absH1.*FFTabs.*sin(PHASEimage+PhaseH1));
Result=(REALPROD+IMAGPROD*sqrt(-1));
FINAL=ifft2(Result);
R1=real(FINAL);


absH2=sqrt((0.*ones(SIZEX,SIZEY)).^2+H2.^2);
PhaseH2=atan2(H2,(0.*ones(SIZEX,SIZEY)));
REALPROD=fftshift(absH2.*FFTabs.*cos(PHASEimage+PhaseH2));
IMAGPROD=fftshift(absH2.*FFTabs.*sin(PHASEimage+PhaseH2));
Result=(REALPROD+IMAGPROD*sqrt(-1));
FINAL=ifft2(Result);
R2=real(FINAL);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Envelope=sqrt(R.^2+R1.^2+R2.^2);
Local_Orientation=atan(R2./R1);
radius=sqrt(R1.^2+R2.^2);
Local_Phase=atan2((R1./abs(R1)).*radius,R);
PM_carrier=cos(Local_Phase);


